diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_pfm.c PDFlib-Lite-7.0.5/libs/pdflib/p_pfm.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_pfm.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_pfm.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_pfm.c,v 1.115.2.3 2007/09/06 18:19:19 kurt Exp $
+/* $Id: p_pfm.c,v 1.115.2.5 2009/07/07 14:02:50 kurt Exp $
  *
  * PDFlib routines for fast reading of PFM font metrics files
  *
@@ -78,6 +78,7 @@
 #define PFM_RUSSIAN_CHARSET     204
 #define PFM_THAI_CHARSET        222
 #define PFM_EASTEUROPE_CHARSET  238
+#define PFM_OEM_CHARSET         255
 
 static const pdc_keyconn pdf_charset_keylist[] =
 {
@@ -92,6 +93,7 @@
     {"cp1251",  PFM_RUSSIAN_CHARSET   },
     {"cp874",   PFM_THAI_CHARSET      },
     {"cp1250",  PFM_EASTEUROPE_CHARSET},
+    {"",        PFM_OEM_CHARSET       },
     {NULL, 0},
 };
 
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_photoshp.c PDFlib-Lite-7.0.5/libs/pdflib/p_photoshp.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_photoshp.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_photoshp.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_photoshp.c,v 1.5.2.8 2008/11/20 17:39:49 kurt Exp $
+/* $Id: p_photoshp.c,v 1.5.2.10 2010/01/18 19:36:14 kurt Exp $
  *
  * PDFlib Photoshop image resource data routines
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_png.c PDFlib-Lite-7.0.5/libs/pdflib/p_png.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_png.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_png.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_png.c,v 1.94.2.10 2009/06/08 11:34:03 tm Exp $
+/* $Id: p_png.c,v 1.94.2.13 2009/08/05 19:48:26 tm Exp $
  *
  * PNG processing for PDFlib
  *
@@ -100,30 +100,15 @@
     pdc_logg_cond(p->pdc, 5, trc_image, "\tlibpng warning: %s\n", message);
 }
 
-/*
- * use the libpng portability aid in an attempt to overcome version differences
- */
-#ifndef png_jmpbuf
-#define png_jmpbuf(png_ptr) ((png_ptr)->jmpbuf)
-#endif
-
 static void
 pdf_libpng_error_handler(png_structp png_ptr, png_const_charp message)
 {
     PDF *p = (PDF *)png_ptr->mem_ptr;
 
-#ifdef PDF_ALIGN16
-    jmp_buf jbuf;
-#endif
-
     pdc_logg_cond(p->pdc, 5, trc_image, "\tlibpng error: %s\n", message);
 
-#ifdef PDF_ALIGN16
-    memcpy(jbuf, png_jmpbuf(png_ptr), sizeof (jmp_buf));
-    longjmp(jbuf, 1);
-#else
-    longjmp(png_jmpbuf(png_ptr), 1);
-#endif
+    /* A better message will be created later */
+    pdc_error(p->pdc, PDF_E_IMAGE_CORRUPT, "PNG", "?", 0, 0);
 }
 
 static void *
@@ -162,14 +147,10 @@
     int imageslot)
 {
     static const char *fn = "pdf_process_PNG_data";
-    pdc_file *save_fp;
     size_t bytecount;
-#ifdef PDF_ALIGN16
-    jmp_buf jbuf;
-#endif
 
     png_uint_32 width, height, ui;
-    png_bytep *row_pointers = NULL, trans;
+    png_bytep * volatile row_pointers = NULL, trans;
     png_color_8p sig_bit;
     png_color_16p trans_values;
     int bit_depth, color_type, i, num_trans;
@@ -211,333 +192,322 @@
         pdc_error(p->pdc, PDC_E_MEM_OUT, fn, 0, 0, 0);
     }
 
-    /* due to alignment bug on itanium machines:
-    ** use well aligned local jbuf instead of sometimes
-    ** bad aligned (allocated) jmp_buf.
-    */
-#ifdef PDF_ALIGN16
-    if (setjmp(jbuf))
-#else
-    if (setjmp(png_jmpbuf(image->info.png.png_ptr)))
-#endif
-    {
-        errcode = PDF_E_IMAGE_CORRUPT;
-        goto PDF_PNG_ERROR;
-    }
-#ifdef PDF_ALIGN16
-    memcpy(png_jmpbuf(image->info.png.png_ptr), jbuf, sizeof (jmp_buf));
-#endif
-
     if (pdf_is_PNG_file(p, image->fp) == pdc_false)
     {
         errcode = PDC_E_IO_BADFORMAT;
         goto PDF_PNG_ERROR;
     }
 
-    /* from file or from memory */
-    png_set_read_fn(image->info.png.png_ptr, image->fp,
-                    (png_rw_ptr) pdf_png_read_data);
-
-    png_set_sig_bytes(image->info.png.png_ptr, 8);
-    png_read_info(image->info.png.png_ptr, image->info.png.info_ptr);
-    png_get_IHDR(image->info.png.png_ptr, image->info.png.info_ptr,
-	    &width, &height, &bit_depth, &color_type, NULL, NULL, NULL);
-
-    image->width        = (pdc_scalar) width;
-    image->height       = (pdc_scalar) height;
-
-    /* reduce 16-bit images to 8 bit since PDF < 1.5 stops at 8 bit */
-    if (p->compatibility < PDC_1_5 && bit_depth == 16)
+    PDC_TRY(p->pdc)
     {
-	png_set_strip_16(image->info.png.png_ptr);
-	bit_depth = 8;
-    }
+	/* from file or from memory */
+	png_set_read_fn(image->info.png.png_ptr, image->fp,
+			(png_rw_ptr) pdf_png_read_data);
+
+	png_set_sig_bytes(image->info.png.png_ptr, 8);
+	png_read_info(image->info.png.png_ptr, image->info.png.info_ptr);
+	png_get_IHDR(image->info.png.png_ptr, image->info.png.info_ptr,
+		&width, &height, &bit_depth, &color_type, NULL, NULL, NULL);
+
+	image->width        = (pdc_scalar) width;
+	image->height       = (pdc_scalar) height;
+	image->bpc          = bit_depth;
 
-    image->bpc		= bit_depth;
+	/* reduce 16-bit images to 8 bit since PDF < 1.5 stops at 8 bit */
+	if (p->compatibility < PDC_1_5 && bit_depth == 16)
+	{
+	    png_set_strip_16(image->info.png.png_ptr);
 
-    /*
-     * We currently don't support a real alpha channel but only binary
-     * tranparency ("poor man's alpha"). For palette images we do our best and
-     * treat alpha values of up to 50% as transparent, and values above 50%
-     * as opaque. Gray and RGB images with an associated alpha channel will
-     * be pre-multiplied by libpng (against white background).
-     */
+	    /* keep bit_depth at 16 since we need it later */
+	    image->bpc = 8;
+	}
+
+	/*
+	 * We currently don't support a real alpha channel but only binary
+	 * transparency ("poor man's alpha"). For palette images we do our
+	 * best and
+	 * treat alpha values of up to 50% as transparent, and values above 50%
+	 * as opaque. Gray and RGB images with an associated alpha channel will
+	 * be pre-multiplied by libpng (against white background).
+	 */
 #define ALPHA_THRESHOLD 128
 
-    switch (color_type)
-    {
-	case PNG_COLOR_TYPE_GRAY_ALPHA:
-	    /* LATER: construct mask from alpha channel */
-	    /*
-	    png_set_IHDR(image->info.png.png_ptr, image->info.png.info_ptr,
-	    	width, height, bit_depth, PNG_COLOR_MASK_ALPHA,
-		PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT,
-		PNG_FILTER_TYPE_DEFAULT);
-	    */
-	    /*
-	     * We strip the alpha channel, and let libpng pre-multiply
-	     * the opacity values to the image data.
-	     */
-	    png_set_strip_alpha(image->info.png.png_ptr);
-	    /* fall through */
-
-	case PNG_COLOR_TYPE_GRAY:
-	    if (png_get_sBIT(image->info.png.png_ptr,
-	    		image->info.png.info_ptr, &sig_bit))
-            {
-		png_set_shift(image->info.png.png_ptr, sig_bit);
-	    }
+	switch (color_type)
+	{
+	    case PNG_COLOR_TYPE_GRAY_ALPHA:
+		/*
+		 * By default let libpng pre-multiply the opacity values
+		 * to the image data. If ignoremask is set, strip the
+		 * alpha channel.
+		 */
+		if (image->ignoremask)
+		    png_set_strip_alpha(image->info.png.png_ptr);
+
+		/* fall through */
+
+	    case PNG_COLOR_TYPE_GRAY:
+		if (png_get_sBIT(image->info.png.png_ptr,
+			    image->info.png.info_ptr, &sig_bit))
+		{
+		    png_set_shift(image->info.png.png_ptr, sig_bit);
+		}
 
-		image->colorspace	= DeviceGray;
+		    image->colorspace	= DeviceGray;
 
-	    image->components	= 1;
-	    break;
+		image->components	= 1;
+		break;
 
-	case PNG_COLOR_TYPE_RGB_ALPHA:
-	    /* LATER: construct mask from alpha channel */
-	    /*
-	     * We strip the alpha channel, and let libpng pre-multiply
-	     * the opacity values to the image data.
-	     */
-	    png_set_strip_alpha(image->info.png.png_ptr);
-	    /* fall through */
-
-	case PNG_COLOR_TYPE_RGB:
-	    if (image->colorspace == pdc_undef)
-		image->colorspace	= DeviceRGB;
-	    image->components	= 3;
+	    case PNG_COLOR_TYPE_RGB_ALPHA:
+		/*
+		 * By default let libpng pre-multiply the opacity values
+		 * to the image data. If ignoremask is set, strip the
+		 * alpha channel.
+		 */
+		if (image->ignoremask)
+		    png_set_strip_alpha(image->info.png.png_ptr);
+
+		/* fall through */
+
+	    case PNG_COLOR_TYPE_RGB:
+		if (image->colorspace == pdc_undef)
+		    image->colorspace	= DeviceRGB;
+		image->components	= 3;
 
-	    break;
+		break;
 
-	case PNG_COLOR_TYPE_PALETTE:
-        {
-            png_colorp pcm;
-
-	    png_get_PLTE(image->info.png.png_ptr, image->info.png.info_ptr,
-		&pcm, &cs.val.indexed.palette_size);
-
-	    colormap =
-		(pdf_colormap *) pdc_malloc(p->pdc, sizeof(pdf_colormap), fn);
-
-	    /* This seems redundant, but the png_colorp structure may not
-	     * be packed on some platforms.
-	     */
-	    for (i = 0; i < cs.val.indexed.palette_size; i++)
+	    case PNG_COLOR_TYPE_PALETTE:
 	    {
-		(*colormap)[i][0] = (pdc_byte) pcm[i].red;
-		(*colormap)[i][1] = (pdc_byte) pcm[i].green;
-		(*colormap)[i][2] = (pdc_byte) pcm[i].blue;
-	    }
+		png_colorp pcm;
 
-	    image->components = 1;
+		png_get_PLTE(image->info.png.png_ptr, image->info.png.info_ptr,
+		    &pcm, &cs.val.indexed.palette_size);
 
-	    /* This case should arguably be prohibited. However, we allow
-	     * it and take the palette indices 0 and 1 as the mask,
-	     * disregarding any color values in the palette.
-	     */
-	    if (image->imagemask) {
-		image->colorspace = DeviceGray;
-		break;
-	    }
+		colormap =
+		    (pdf_colormap *) pdc_malloc(p->pdc, sizeof(pdf_colormap),
+		    			fn);
+
+		/* This seems redundant, but the png_colorp structure may not
+		 * be packed on some platforms.
+		 */
+		for (i = 0; i < cs.val.indexed.palette_size; i++)
+		{
+		    (*colormap)[i][0] = (pdc_byte) pcm[i].red;
+		    (*colormap)[i][1] = (pdc_byte) pcm[i].green;
+		    (*colormap)[i][2] = (pdc_byte) pcm[i].blue;
+		}
 
-		cs.type = Indexed;
-		cs.val.indexed.base = DeviceRGB;
-		cs.val.indexed.colormap = colormap;
-		cs.val.indexed.colormap_id = PDC_BAD_ID;
-		slot = pdf_add_colorspace(p, &cs, pdc_false);
+		image->components = 1;
 
-		image->colorspace = slot;
+		/* This case should arguably be prohibited. However, we allow
+		 * it and take the palette indices 0 and 1 as the mask,
+		 * disregarding any color values in the palette.
+		 */
+		if (image->imagemask) {
+		    image->colorspace = DeviceGray;
+		    break;
+		}
 
-        }
-	break;
-    }
-    if (colormap)
-       pdc_free(p->pdc, colormap);
+		    cs.type = Indexed;
+		    cs.val.indexed.base = DeviceRGB;
+		    cs.val.indexed.colormap = colormap;
+		    cs.val.indexed.colormap_id = PDC_BAD_ID;
+		    slot = pdf_add_colorspace(p, &cs, pdc_false);
 
-    if (image->imagemask)
-    {
-	if (image->components != 1)
-        {
-	    errcode = PDF_E_IMAGE_BADMASK;
-	    goto PDF_PNG_ERROR;
+		    image->colorspace = slot;
+
+	    }
+	    break;
 	}
+	if (colormap)
+	   pdc_free(p->pdc, colormap);
 
-	if (p->compatibility <= PDC_1_3) {
-	    if (image->components != 1 || image->bpc != 1)
-            {
-		errcode = PDF_E_IMAGE_MASK1BIT13;
+	if (image->imagemask)
+	{
+	    if (image->components != 1)
+	    {
+		errcode = PDF_E_IMAGE_BADMASK;
+		PDC_EXIT_TRY(p->pdc);
 		goto PDF_PNG_ERROR;
 	    }
-	}
-        else if (image->bpc > 1)
-        {
-	    /* images with more than one bit will be written as /SMask,
-	     * and don't require an /ImageMask entry.
-	     */
-	    image->imagemask = pdc_false;
-	}
-	image->colorspace = DeviceGray;
-    }
 
-    /* we invert this flag later */
-    if (image->ignoremask)
-        image->transparent = pdc_true;
-
-    /* let libpng expand interlaced images */
-    (void) png_set_interlace_handling(image->info.png.png_ptr);
-
-    /* read the physical dimensions chunk to find the resolution values */
-    dpi_x = (pdc_scalar) png_get_x_pixels_per_meter(image->info.png.png_ptr,
-    		image->info.png.info_ptr);
-    dpi_y = (pdc_scalar) png_get_y_pixels_per_meter(image->info.png.png_ptr,
-    		image->info.png.info_ptr);
-
-    if (dpi_x != 0 && dpi_y != 0)
-    {	/* absolute values */
-        image->dpi_x = dpi_x * PDC_INCH2METER;
-        image->dpi_y = dpi_y * PDC_INCH2METER;
+	    if (p->compatibility <= PDC_1_3) {
+		if (image->components != 1 || image->bpc != 1)
+		{
+		    errcode = PDF_E_IMAGE_MASK1BIT13;
+		    PDC_EXIT_TRY(p->pdc);
+		    goto PDF_PNG_ERROR;
+		}
+	    }
+	    else if (image->bpc > 1)
+	    {
+		/* images with more than one bit will be written as /SMask,
+		 * and don't require an /ImageMask entry.
+		 */
+		image->imagemask = pdc_false;
+	    }
+	    image->colorspace = DeviceGray;
+	}
 
-    }
-    else
-    {				/* aspect ratio */
-	image->dpi_y = -png_get_pixel_aspect_ratio(image->info.png.png_ptr,
-			    image->info.png.info_ptr);
+	/* we invert this flag later */
+	if (image->ignoremask)
+	    image->transparent = pdc_true;
+
+	/* let libpng expand interlaced images */
+	(void) png_set_interlace_handling(image->info.png.png_ptr);
+
+	/* read the physical dimensions chunk to find the resolution values */
+	dpi_x = (pdc_scalar) png_get_x_pixels_per_meter(image->info.png.png_ptr,
+		    image->info.png.info_ptr);
+	dpi_y = (pdc_scalar) png_get_y_pixels_per_meter(image->info.png.png_ptr,
+		    image->info.png.info_ptr);
+
+	if (dpi_x != 0 && dpi_y != 0)
+	{	/* absolute values */
+	    image->dpi_x = dpi_x * PDC_INCH2METER;
+	    image->dpi_y = dpi_y * PDC_INCH2METER;
 
-	if (image->dpi_y == 0)	/* unknown */
-	    image->dpi_x = 0;
+	}
 	else
-	    image->dpi_x = -1.0;
-    }
+	{				/* aspect ratio */
+	    image->dpi_y = -png_get_pixel_aspect_ratio(image->info.png.png_ptr,
+				image->info.png.info_ptr);
 
-    /* read the transparency chunk */
-    if (png_get_valid(image->info.png.png_ptr, image->info.png.info_ptr,
-    	PNG_INFO_tRNS))
-    {
-	png_get_tRNS(image->info.png.png_ptr, image->info.png.info_ptr,
-	    &trans, &num_trans, &trans_values);
-	if (num_trans > 0)
-        {
-	    if (color_type == PNG_COLOR_TYPE_GRAY)
-            {
-		image->transparent = !image->transparent;
-		/* LATER: scale down 16-bit transparency values ? */
-		image->transval[0] = (pdc_byte) trans_values[0].gray;
+	    if (image->dpi_y == 0)	/* unknown */
+		image->dpi_x = 0;
+	    else
+		image->dpi_x = -1.0;
+	}
 
-	    }
-            else if (color_type == PNG_COLOR_TYPE_RGB)
-            {
-		image->transparent = !image->transparent;
-		/* LATER: scale down 16-bit transparency values ? */
-		image->transval[0] = (pdc_byte) trans_values[0].red;
-		image->transval[1] = (pdc_byte) trans_values[0].green;
-		image->transval[2] = (pdc_byte) trans_values[0].blue;
+	/* read the transparency chunk */
+	if (!image->ignoremask &&
+	    png_get_valid(image->info.png.png_ptr, image->info.png.info_ptr,
+	    PNG_INFO_tRNS))
+	{
+	    png_get_tRNS(image->info.png.png_ptr, image->info.png.info_ptr,
+		&trans, &num_trans, &trans_values);
+	    if (num_trans > 0)
+	    {
+		if (color_type == PNG_COLOR_TYPE_GRAY)
+		{
+		    image->transparent = !image->transparent;
+		    /* LATER: scale down 16-bit transparency values ? */
+		    image->transval[0] = (pdc_byte) trans_values[0].gray;
 
-	    }
-            else if (color_type == PNG_COLOR_TYPE_PALETTE)
-            {
-		/* we use the first transparent entry in the tRNS palette */
-		for (i = 0; i < num_trans; i++)
-                {
-		    if ((pdc_byte) trans[i] < ALPHA_THRESHOLD)
-                    {
-			image->transparent = !image->transparent;
-			image->transval[0] = (pdc_byte) i;
-			break;
+		}
+		else if (color_type == PNG_COLOR_TYPE_RGB)
+		{
+		    image->transparent = !image->transparent;
+		    /* LATER: scale down 16-bit transparency values ? */
+		    image->transval[0] = (pdc_byte) trans_values[0].red;
+		    image->transval[1] = (pdc_byte) trans_values[0].green;
+		    image->transval[2] = (pdc_byte) trans_values[0].blue;
+
+		}
+		else if (color_type == PNG_COLOR_TYPE_PALETTE)
+		{
+		    /* we use the first transparent entry in the tRNS palette */
+		    for (i = 0; i < num_trans; i++)
+		    {
+			if ((pdc_byte) trans[i] < ALPHA_THRESHOLD)
+			{
+			    image->transparent = !image->transparent;
+			    image->transval[0] = (pdc_byte) i;
+			    break;
+			}
 		    }
 		}
 	    }
 	}
-    }
-
 
 
 
-    png_read_update_info(image->info.png.png_ptr, image->info.png.info_ptr);
 
-    image->info.png.rowbytes =
-	png_get_rowbytes(image->info.png.png_ptr, image->info.png.info_ptr);
+	/* Provide a suitable background for images with alpha channel */
+	if (!image->ignoremask &&
+	    (color_type == PNG_COLOR_TYPE_GRAY_ALPHA ||
+	    color_type == PNG_COLOR_TYPE_RGB_ALPHA))
+	{
+	    png_color_16p image_background;
 
-    /* Check for overflow */
-    bytecount = image->info.png.rowbytes * height;
-    if (bytecount / height != image->info.png.rowbytes)
-    {
-	errcode = PDF_E_IMAGE_TOO_LARGE;
-	goto PDF_PNG_ERROR;
-    }
+	    if (png_get_bKGD(image->info.png.png_ptr, image->info.png.info_ptr,
+			    &image_background))
+	    {
+		png_set_background(image->info.png.png_ptr, image_background,
+		    PNG_BACKGROUND_GAMMA_FILE, 1, 1.0);
+	    }
+	    else
+	    {
+		png_color_16 my_white;
 
-    image->info.png.raster = (pdc_byte *)
-	pdc_calloc(p->pdc,image->info.png.rowbytes * height, fn);
+		if (bit_depth == 8)
+		{
+		    my_white.red	= 0xFF;
+		    my_white.green	= 0xFF;
+		    my_white.blue	= 0xFF;
+		    my_white.gray	= 0xFF;
+		}
+		else
+		{
+		    my_white.red	= 0xFFFF;
+		    my_white.green	= 0xFFFF;
+		    my_white.blue	= 0xFFFF;
+		    my_white.gray	= 0xFFFF;
+		}
 
-    row_pointers = (png_bytep *)
-	pdc_malloc(p->pdc, height * sizeof(png_bytep), fn);
+		png_set_background(image->info.png.png_ptr, &my_white,
+		    PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0);
+	    }
+	}
 
-    for (ui = 0; ui < height; ui++)
-    {
-	row_pointers[ui] =
-	    image->info.png.raster + ui * image->info.png.rowbytes;
-    }
+	png_read_update_info(image->info.png.png_ptr, image->info.png.info_ptr);
 
-    /* try the simple way:
-    */
-    save_fp = image->fp;
-
-    image->src.init		= pdf_data_source_PNG_init;
-    image->src.fill		= pdf_data_source_PNG_fill;
-    image->src.terminate	= pdf_data_source_PNG_terminate;
-    image->src.private_data	= (void *) image;
-
-
-    image->fp = pdc_fsearch_fopen(p->pdc, image->filename, NULL, NULL,
-                                  PDC_FILE_BINARY);
-    if (image->fp != (pdc_file *) 0)
-	pdc_fclose(image->fp);
-
-    image->fp = save_fp;
-
-    /* Provide a suitable background for images with alpha channel */
-    if (color_type == PNG_COLOR_TYPE_GRAY_ALPHA ||
-	color_type == PNG_COLOR_TYPE_RGB_ALPHA)
-    {
-	png_color_16p image_background;
+	image->info.png.rowbytes =
+	    png_get_rowbytes(image->info.png.png_ptr, image->info.png.info_ptr);
 
-	if (png_get_bKGD(image->info.png.png_ptr, image->info.png.info_ptr,
-			&image_background))
+	/* Check for overflow */
+	bytecount = image->info.png.rowbytes * height;
+	if (bytecount / height != image->info.png.rowbytes)
 	{
-	    png_set_background(image->info.png.png_ptr, image_background,
-		PNG_BACKGROUND_GAMMA_FILE, 1, 1.0);
+	    errcode = PDF_E_IMAGE_TOO_LARGE;
+	    PDC_EXIT_TRY(p->pdc);
+	    goto PDF_PNG_ERROR;
 	}
-	else
-	{
-	    png_color_16 my_white;
 
-	    if (bit_depth == 8)
-	    {
-		my_white.red	= 0xFF;
-		my_white.green	= 0xFF;
-		my_white.blue	= 0xFF;
-		my_white.gray	= 0xFF;
-	    }
-	    else
-	    {
-		my_white.red	= 0xFFFF;
-		my_white.green	= 0xFFFF;
-		my_white.blue	= 0xFFFF;
-		my_white.gray	= 0xFFFF;
-	    }
+	image->info.png.raster = (pdc_byte *)
+	    pdc_calloc(p->pdc,image->info.png.rowbytes * height, fn);
+
+	row_pointers = (png_bytep *)
+	    pdc_malloc(p->pdc, height * sizeof(png_bytep), fn);
 
-	    png_set_background(image->info.png.png_ptr, &my_white,
-		PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0);
+	for (ui = 0; ui < height; ui++)
+	{
+	    row_pointers[ui] =
+		image->info.png.raster + ui * image->info.png.rowbytes;
 	}
-    }
 
-    /* fetch the actual image data */
-    png_read_image(image->info.png.png_ptr, row_pointers);
+	image->src.init		= pdf_data_source_PNG_init;
+	image->src.fill		= pdf_data_source_PNG_fill;
+	image->src.terminate	= pdf_data_source_PNG_terminate;
+	image->src.private_data	= (void *) image;
+
+	/* fetch the actual image data */
+	png_read_image(image->info.png.png_ptr, row_pointers);
 
-    image->in_use		= pdc_true;		/* mark slot as used */
+	/* mark slot as used */
+	image->in_use		= pdc_true;
 
-    pdf_put_image(p, imageslot, pdc_true, pdc_true);
+	pdf_put_image(p, imageslot, pdc_true, pdc_true);
+    }
+    PDC_CATCH(p->pdc)
+    {
+        image->corrupt = pdc_true;
+    }
 
-    pdc_free(p->pdc, image->info.png.raster);
+    if (image->info.png.raster)
+    {
+	pdc_free(p->pdc, image->info.png.raster);
+	image->info.png.raster = NULL;
+    }
     if (row_pointers != NULL)
         pdc_free(p->pdc, row_pointers);
 
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_table.c PDFlib-Lite-7.0.5/libs/pdflib/p_table.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_table.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_table.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_table.c,v 1.88.2.38 2009/05/08 10:25:23 kurt Exp $
+/* $Id: p_table.c,v 1.88.2.43 2009/07/31 10:41:03 kurt Exp $
  *
  * PDFlib table function
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_tagged.c PDFlib-Lite-7.0.5/libs/pdflib/p_tagged.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_tagged.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_tagged.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_tagged.c,v 1.146.2.8 2008/07/14 14:38:58 stm Exp $
+/* $Id: p_tagged.c,v 1.146.2.9 2009/09/15 13:43:32 serge Exp $
  *
  * PDFlib marked content routines
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_template.c PDFlib-Lite-7.0.5/libs/pdflib/p_template.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_template.c	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_template.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_template.c,v 1.82.2.9 2009/04/15 12:06:35 york Exp $
+/* $Id: p_template.c,v 1.82.2.11 2010/03/17 12:52:05 kurt Exp $
  *
  * PDFlib template routines
  *
@@ -138,7 +138,9 @@
         pdc_get_optvalues(keyword, resopts, &topdown, NULL);
 
 	if (pdc_get_optvalues("transparencygroup", resopts, NULL, &slist))
-	    pdf_set_transgroup(p, slist[0], &image->tgroup);
+        {
+            pdf_set_transgroup(p, slist[0], &image->tgroup);
+        }
 
         keyword = "iconname";
         if (pdc_get_optvalues(keyword, resopts, NULL, NULL))
@@ -154,12 +156,12 @@
 
 
 
-
-
     p->ydirection = topdown ? -1 : 1;
     pdf_pg_suspend(p);
     PDF_SET_STATE(p, pdf_state_template);
 
+
+
     /* form xobject */
     image->no = pdf_new_xobject(p, form_xobject, PDC_NEW_ID);
     image->width = width;
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_text.c PDFlib-Lite-7.0.5/libs/pdflib/p_text.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_text.c	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_text.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_text.c,v 1.409.2.60 2009/06/04 11:22:04 york Exp $
+/* $Id: p_text.c,v 1.409.2.63 2009/09/23 19:07:20 kurt Exp $
  *
  * PDFlib text routines
  *
@@ -25,7 +25,6 @@
 #include "p_layer.h"
 #include "p_tagged.h"
 
-
 /* --------------------- Text state and options functions ------------------- */
 
 struct pdf_tstate_s
@@ -1442,11 +1441,13 @@
                     }
                 }
 
-                if (newcharlen == 1)
-                    outtext[icp] = (pdc_byte) code;
-                else
-                    usouttext[icp] = (pdc_ushort) code;
-                icp++;
+                {
+                    if (newcharlen == 1)
+                        outtext[icp] = (pdc_byte) code;
+                    else
+                        usouttext[icp] = (pdc_ushort) code;
+                    icp++;
+                }
             }
 
             break;
@@ -1579,25 +1580,27 @@
                     }
                 }
 
-                if (newcharlen == 1)
-                {
-                    outtext[icp] = (pdc_byte) code;
-                }
-                else
-                {
-                    usouttext[icp] = (pdc_ushort) usv;
-                }
-                if (nv > 1)
                 {
                     if (newcharlen == 1)
-                        ligatlist = pdf_register_ligat(p, ligatlist, icp, nv,
-                                                       cglist, newcharlen);
+                    {
+                        outtext[icp] = (pdc_byte) code;
+                    }
                     else
-                        ligatlist = pdf_register_ligat(p, ligatlist,
-                                              icp, nv, uvlist, newcharlen);
-                    nv = 1;
+                    {
+                        usouttext[icp] = (pdc_ushort) usv;
+                    }
+                    if (nv > 1)
+                    {
+                        if (newcharlen == 1)
+                            ligatlist = pdf_register_ligat(p, ligatlist,
+                                                  icp, nv, cglist, newcharlen);
+                        else
+                            ligatlist = pdf_register_ligat(p, ligatlist,
+                                                  icp, nv, uvlist, newcharlen);
+                        nv = 1;
+                    }
+                    icp++;
                 }
-                icp++;
             }
 
             break;
@@ -1658,6 +1661,10 @@
                 pdf_cleanup_ligat(p, ligatlist);
             }
         }
+        else if (enc != pdc_cid)
+        {
+            *outlen = 0;
+        }
     }
 
     *outtext_p = outtext;
@@ -2051,37 +2058,12 @@
     pdc_bool hasdeco = to->underline || to->overline || to->strikeout;
     pdc_bool takeTJ = pdc_false;
 
-    /* default linewidth for underlinewidth and strokewidth */
-    if (hasdeco || (to->mask & (1 << to_strokewidth)))
-    {
-        if (currfont->ft.m.underlineThickness == 0)
-            currfont->ft.m.underlineThickness = 50;
-        deflinewidth = fabs(to->horizscaling * font2user *
-                            currfont->ft.m.underlineThickness);
-    }
-
     /* fill and stroke color */
     if (to->mask & (1 << to_fillcolor))
         pdf_set_coloropt(p, (int) pdf_fill, &to->fillcolor);
     if (to->mask & (1 << to_strokecolor))
         pdf_set_coloropt(p, (int) pdf_stroke, &to->strokecolor);
 
-
-    /* stroke width and dasharray for stroked text */
-    if (to->mask & (1 << to_strokewidth))
-    {
-        if (to->strokewidth == PDF_UNDERLINEWIDTH_AUTO)
-        {
-            linewidth = deflinewidth;
-        }
-        else
-        {
-            linewidth = to->strokewidth;
-            if ((to->pcmask & (1 << to_strokewidth)))
-                linewidth *= fabs(to->fontsize);
-        }
-        pdf__setlinewidth(p, linewidth);
-    }
     if (to->mask & (1 << to_dasharray))
         pdf__setdash(p, to->dasharray[0], to->dasharray[1]);
 
@@ -2100,6 +2082,11 @@
 
         pdf__save(p);
 
+        if (currfont->ft.m.underlineThickness == 0)
+            currfont->ft.m.underlineThickness = 50;
+        deflinewidth = fabs(to->horizscaling * font2user *
+                            currfont->ft.m.underlineThickness);
+
         if (to->underlinewidth == PDF_UNDERLINEWIDTH_AUTO)
         {
             linewidth = deflinewidth;
@@ -2190,6 +2177,22 @@
         pdf__restore(p);
     }
 
+    /* stroke width and dasharray for stroked text */
+    if (to->mask & (1 << to_strokewidth) || to->textrendering)
+    {
+        if (to->strokewidth == PDF_UNDERLINEWIDTH_AUTO)
+        {
+            linewidth = PDC_ABS(to->horizscaling * font2user * 30);
+        }
+        else
+        {
+            linewidth = to->strokewidth;
+            if ((to->pcmask & (1 << to_strokewidth)))
+                linewidth *= fabs(to->fontsize);
+        }
+        pdf__setlinewidth(p, linewidth);
+    }
+
 
 
     /* wordspacing */
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_textflow.c PDFlib-Lite-7.0.5/libs/pdflib/p_textflow.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_textflow.c	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_textflow.c	2010-04-29 15:50:07.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_textflow.c,v 1.306.2.130 2009/05/28 15:45:41 kurt Exp $
+/* $Id: p_textflow.c,v 1.306.2.141 2010/03/18 12:02:29 kurt Exp $
  *
  * PDFlib textflow function
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_tiff.c PDFlib-Lite-7.0.5/libs/pdflib/p_tiff.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_tiff.c	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_tiff.c	2010-04-29 15:50:07.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_tiff.c,v 1.134.2.40 2009/02/24 15:58:51 tm Exp $
+/* $Id: p_tiff.c,v 1.134.2.41 2010/01/14 11:04:03 tm Exp $
  *
  * TIFF processing for PDFlib
  *
@@ -550,6 +550,18 @@
 	image->use_raw = pdc_false;
     }
 
+    /* Can't pass through grayscale or RGB with additional alpha channel.
+     * Some TIFF images do not count the alpha channel as extra channel.
+     */
+    if (extra == 0 && 
+	((photometric == PHOTOMETRIC_RGB && components == 4) ||
+	 ((photometric == PHOTOMETRIC_MINISBLACK || 
+	   photometric == PHOTOMETRIC_MINISWHITE) && components == 2)))
+    {
+	image->components -= 1;	/* ignore the alpha channel */
+	image->use_raw = pdc_false;
+    }
+
     /* PDF doesn't support other values of the color depth */
     if (bpc != 1 && bpc != 2 && bpc != 4 && bpc != 8 && bpc != 16)
 	image->use_raw = pdc_false;
@@ -915,7 +927,6 @@
                     /* if it's not separated it must be RGB with alpha */
                     image->components = 3;
                     image->colorspace = DeviceRGB;
-                    image->compression = pdf_comp_none;
                 }
                 break;
 
